function output=GOvectorscorer(input, input_genes,species)
  %output=assess_vec_b(input,genes [symbs or ncbi],species)



  data_genes=load([species 'list']);
data_genes=orderfields(data_genes);
data_genes=struct2cell(data_genes);
gene_list=data_genes{1};
gene_list_ncbi=data_genes{end};

data_GOgenemat=load([species '_GOdata']);
data_GOgenemat=orderfields(data_GOgenemat);
data_GOgenemat=struct2cell(data_GOgenemat);
GOgenemat=data_GOgenemat{end};


if iscell(input_genes)>0
    [whichgenes,loc]=ismember(gene_list,input_genes);
end
if isnumeric(input_genes)>0
    [whichgenes,loc]=ismember(gene_list_ncbi,input_genes);
end

input=input(loc(loc>0));
whichgenes=logical(whichgenes);

GOgenemat=GOgenemat(whichgenes,:);

ranks=tiedrank(input);
ROC_using_sorted=nan(size(GOgenemat,2),1);

for i=1:size(GOgenemat,2)
  TF=logical(GOgenemat(:,i));
if sum(TF)>20 && sum(TF)<1000
ROC_using_sorted(i)=(sum(ranks(TF))/sum(TF)-(sum(TF)+1)/2)/sum(~TF);
end
end

output=ROC_using_sorted;
