function [ROC,fp,tp]=ROC_opt(input,out_of_list,species)
  %[ROC,fp,tp]=ROC_opt(input,out_of_list,'species')
%input either gene symbs cell or numeric ncbis
%output ROC is uses tied ranks, fp,tp just default sorted



TF=0;

    [TF,loc]=ismember(out_of_list,input);
truest_opt_list=calc_opt_list(out_of_list,species);    

TF(isnan(truest_opt_list))=[];
truest_opt_list(isnan(truest_opt_list))=[];

ranks=tiedrank(truest_opt_list);
ROC=(sum(ranks(TF))/sum(TF)-(sum(TF)+1)/2)/sum(~TF);
truest_opt_list(truest_opt_list==0)=-rand(sum(truest_opt_list==0),1);
truest_opt_list(isnan(truest_opt_list))=-rand(sum(isnan(truest_opt_list)),1);
[m,n]=sort(truest_opt_list,'descend');
TF=TF(n);
fp=cumsum(~(TF)/sum(~TF));
tp=cumsum(TF/sum(TF));
