function [output]=calc_opt_list(input_genes,species);
%[opt_scores]=calc_opt_list(input_genes,'species');

data_genes=load([species 'list']);
data_genes=orderfields(data_genes);
data_genes=struct2cell(data_genes);
gene_list=data_genes{1};
  gene_list_ncbi=data_genes{end};

data_GOgenemat=load([species '_GOdata']);
data_GOgenemat=orderfields(data_GOgenemat);
data_GOgenemat=struct2cell(data_GOgenemat);
GOgenemat=data_GOgenemat{end};




if iscell(input_genes)>0
    [TF,loc]=ismember(gene_list,input_genes);
newlist=gene_list(TF);
end
if isnumeric(input_genes)>0
    [TF,loc]=ismember(gene_list_ncbi,input_genes);
    newlist=gene_list_ncbi(TF);
end


GOgenemat=GOgenemat(TF,:);
vec_mult=sum(GOgenemat).*(size(GOgenemat,1)-sum(GOgenemat));
opt_scores=(1./vec_mult)*GOgenemat';

[newTF,newloc]=ismember(input_genes,newlist);
output=nan(length(input_genes),1);
output(newTF)=opt_scores(newloc(newloc>0));
